/*
 * Created on Aug 16, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package isac.BrowserServlet;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcClient;
import org.apache.xmlrpc.XmlRpcException;

import isac.browserdialog.BDialog;
import isac.session.OManager;
import isac.session.SDialog;
/**
 * @author gismo
 *
 * The InformationProcessor builds the bridge between BrowserFrontend
 * and BrowserDialog. 
 */
public class InformationProcessor {

    static protected String login(String username, String password){
	try{
	    XmlRpcClient sdialog = new XmlRpcClient("http://localhost:1050");
	    Vector params = new Vector();
	    params.add(username);
	    params.add(password);
	    Vector response = (Vector) sdialog.execute("SDialog.login", params);
	    if(response.size()>0)
		return (String)response.elementAt(0);
	}catch(MalformedURLException e) {
	    e.printStackTrace();
	} catch (XmlRpcException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	return null;
    }

	static protected String rpcLogin(String username, String password){
		SDialog sd = getSDialog();
		try {
			return (String)(sd.login(username, password).elementAt(0));
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	private static BDialog getBDialog(String session){
		String name = "//localhost/isac-ObjectManager";
		try{
			System.out.println("connect to ObjectManager"+name);
			Object lookup = Naming.lookup(name);
			return ((OManager)lookup).getBrowserDialog(session);
		}
		catch(RemoteException exc){
			System.err.println("no rmiregistry runing on server "+name+
			" no connection possible --- try later");
			System.err.println("serverCom exception: " + exc.getMessage());
		//            exc.printStackTrace();
		}
		catch(NotBoundException exc){
			System.err.println("servercom: notboundexc: "+ exc.getMessage());
			System.err.println("server not found - try to connect to Proxy");
		}
		catch(java.net.MalformedURLException exc){
			System.err.println("servercom: MalformedURLException: "+ exc.getMessage());
			exc.printStackTrace();
		}
		return null;
	}
	private static SDialog getSDialog(){
	String name= "//localhost/isac-ObjectManager";
	try {
		System.out.println("connect to ObjectManager: "+name);
		Object lookup =  Naming.lookup(name);
		return ((OManager) lookup).getSessionDialog();
	}
	catch(RemoteException exc){
		System.err.println("no rmiregistry runing on server "+name+
		" no connection possible --- try later");
		System.err.println("serverCom exception: " + exc.getMessage());
	//            exc.printStackTrace();
	}
	catch(NotBoundException exc){
		System.err.println("servercom: notboundexc: "+ exc.getMessage());
		System.err.println("server not found - try to connect to Proxy");
	}
	catch(java.net.MalformedURLException exc){
		System.err.println("servercom: MalformedURLException: "+ exc.getMessage());
		exc.printStackTrace();
	}
	return null;
}


	static protected String loadnString(String function, Vector parameter){
	XmlRpcClient bdialog;
	String xmlsource="";
	try {
		bdialog = new XmlRpcClient("http://localhost:1040");
		Vector result = (Vector) bdialog.execute(function, parameter);
		xmlsource = (String)result.firstElement();
	} catch (MalformedURLException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (XmlRpcException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	return xmlsource;
	}

	static protected Vector loadVector(String function, Vector parameter){
	Vector return_vect=new Vector();
	XmlRpcClient bdialog;
	String xmlsource="";
	try {
		bdialog = new XmlRpcClient("http://localhost:1040");
		return_vect = (Vector) bdialog.execute(function, parameter);
	} catch (MalformedURLException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (XmlRpcException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	return return_vect;
	}

	static protected String loadHierarchy(String session, String type){
		BDialog bd = getBDialog(session);
		try {
			return bd.loadHierarchy(type);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "<DESCRIPTION> not found </DESCRIPTION>";
	}

	static protected String loadXML(String session, String type, String content_id){
		BDialog bd = getBDialog(session);
		try {
			return bd.loadContent(type, content_id);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "<DESCRIPTION> not found </DESCRIPTION>";
	}

    static protected Reader loadsKEObject(String function, Vector parameter){
	XmlRpcClient bdialog;
	String xmlsource="";
	try {
	    bdialog = new XmlRpcClient("http://localhost:1040");
	    Vector result = (Vector) bdialog.execute(function, parameter);
	    if(result.size()>0)
	    	xmlsource = (String)result.firstElement();
	    else
	    	xmlsource = "";
	} catch (MalformedURLException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (XmlRpcException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	return new StringReader(xmlsource);
    }

	public static String rpcGetUsername(String session_id){
		SDialog sd = getSDialog();
		try {
			String username;
			if((username=sd.getUsername(session_id)).equals(""))
				return null;
			return username;
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * @param session_id
	 * @return
	 */
	public static String getUsername(String session_id) {
		XmlRpcClient bdialog;
		String xmlsource="";
		Vector parameter=new Vector();
		parameter.add(session_id);
		try {
			bdialog = new XmlRpcClient("http://localhost:1050");
			String result = (String) bdialog.execute("SDialog.getUsername", parameter);
			if(result.equals(""))
				return null;
			return result;
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XmlRpcException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		// TODO contact the sessiondialog and ask about the username
		return null;
	}

}
