/*
 * Created on Jun 24, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package isac.BrowserServlet;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;

/**
 * @author gismo
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LoadHierarchy extends HttpServlet {	   
    static final int PBLTREE_XSL=1;
    static final int METTREE_XSL=2;
    static final int EXPTREE_XSL=3;
    static final int SIMPLE_HIERARCHY_XSL=4;
    static final int SIMPLE_PBL_NODE=5;

    /* (non-Javadoc)
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1)
	throws ServletException, IOException {
	String path="/opt/isac/isacxml/xml/met/met_1.xml";
	if(arg0.getPathInfo()!=null)
	    path = arg0.getPathInfo();
	arg1.setContentType("text/html; charset=UTF-8");  
	StringTokenizer tokens = new StringTokenizer(path, "/");
	HttpSession session = arg0.getSession();
	//String command=tokens.nextToken();
	buildHierarchy(tokens, arg0, arg1);
	return;
    }

    /**
     * Loads all pages which build up the
     * <code>Browser</code>. Some are dynamically generated
     * (java-code to build up the JavaScript-tree) while others are
     * statically stored (images for the Tree, Java-Script files,
     * frameset)
     * 
     */
    protected void buildHierarchy(StringTokenizer tokens, 
				  HttpServletRequest request, 
				  HttpServletResponse response){
	String path = "";
	String session = (String)request.getSession().getAttribute("session_id");
	if(session==null)
	    session="";
	
	String type = tokens.nextToken();
	
	if(!tokens.hasMoreTokens())
	    path="/index.html";
	else
	    while(tokens.hasMoreTokens())
		path+="/"+tokens.nextToken();
	try{		
	    if(path.endsWith("code.html")){		
		Vector parameter=new Vector();
		parameter.add(session);
		parameter.add(type);
		Vector result;	    
		Source xslSource=null;
		Source xmlSource = new StreamSource(new StringReader(InformationProcessor.
							loadHierarchy(session, type)));
//		Source xmlSource = new StreamSource(InformationProcessor.
//						    loadKEObject("BDialog.loadHierarchy", 
//								 parameter));
		if(type.equals("pbl"))
		    xslSource = new StreamSource(loadTextFile(PBLTREE_XSL));			
		else if(type.equals("met"))
		    xslSource = new StreamSource(loadTextFile(METTREE_XSL));
		else 
		    xslSource = new StreamSource(loadTextFile(EXPTREE_XSL));
		String header = toString(loadTextFile("/opt/isac/isacxml/xml/pbl/codeheader.html"));
		String footer = toString(loadTextFile("/opt/isac/isacxml/xml/pbl/codefooter.html"));

		// Perform the transformation, sending the output to the response.
		java.io.PrintWriter out = response.getWriter();
		out.print(header);
		Encoder.encodeInformation(xslSource, xmlSource, out);
		out.print(footer);
	    }
	    else{
		InputStream istream = getClass().getResourceAsStream("/isac/BrowserServlet/jscript/"+path);
		int input;
		while( (input = istream.read()) != -1 ) {
		    response.getOutputStream().write(input);
		}
	    }
		
	    
	}catch(IOException exc){
	    System.out.println("bla");
	}
    }

    protected String toString(InputStream istream){
	StringBuffer buf = new StringBuffer(10000);
	int input;
	try {
	    while( (input = istream.read()) != -1 ) {
		buf.append((char)input);
	    }
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	return buf.toString();
    }

    /**
     * loads textfiles which can be changed to adjust the look and
     * feel - this containes files like html-sources, xsl files,
     * css-files
     */
    protected InputStream loadTextFile(int type){
	String filename = "";
	switch(type){
	case (PBLTREE_XSL): filename="/opt/isac/isacxml/xml/pbl/pbl_hierarchy_jmenu.xsl";
	    break;
	case(METTREE_XSL):filename="/opt/isac/isacxml/xml/met/met_hierarchy_jmenu.xsl";
	    break;
	case(EXPTREE_XSL):filename="/opt/isac/isacxml/xml/exp/exp_hierarchy_jmenu.xsl";
	    break;
	case(SIMPLE_HIERARCHY_XSL): filename = "/opt/isac/isacxml/xml/pbl/pbl_hierarchy.xsl";
	    break;
	case(SIMPLE_PBL_NODE): filename = "/opt/isac/isacxml/xml/pbl/pbl_node_content.xsl";
	    break;
	}
	return loadTextFile(filename);
    }
        
    protected InputStream loadTextFile(String filename){	
	try {
	    return (new URL("file", "", filename)).openStream();
	} catch (MalformedURLException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	} catch (IOException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	return null;
    }
}
