/*
 * Created on Aug 18, 2003
*/

package isac.bridge;

/**
 * @author rgradisc
*/

import java.io.BufferedReader;
import java.io.IOException;

public class ClientInputWorker implements Runnable {

  private Client client;
  BufferedReader in = null;

  /**
   * Constructor: create a new ClientInputWorker
   * @param client The client to be served
   * @param in reads lines from Socketconnection
   */
  public ClientInputWorker(Client client, BufferedReader in) {
    this.client = client;
    this.in = in;
  }

  /**
   * This method will be called when the thread starts nunning
   */
  public void run() {
    String line = "";
    try {
      while (line != null) {
        line = in.readLine();
        client.processResponse(line);
        /*
        XMLParser xmlp = new XMLParser();
        Document d = xmlp.parseXMLString(line);
        xmlp.countElems(d);
        xmlp.writeDOM(d);
        xmlp.formatDOM(d);
        */
      }
    } catch (IOException e) {
      //e.printStackTrace();
      client.processResponse(null);
    } catch (NullPointerException e) {      	      
    }

  }

}
