/*
 * Created on Aug 13, 2003
 */
package isac.bridge;

/**
 * @author rgradisc
 */

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Vector;

public class KI2ClientsServer implements Runnable {

  private static final String START_SEQ = "@@@@@begin@@@@@";
  private static final String END_SEQ = "@@@@@end@@@@@";

  //private BufferedReader smlReader;
  private ClientList clientList;
  private BridgeMain bridge;
  private Vector timeOutTimes;

  //---------------------------------------------------------------
  public KI2ClientsServer(BridgeMain bridge) {
    //this.smlReader = bridge.getSmlReader();
    this.clientList = bridge.getClientList();
    this.timeOutTimes = bridge.getTimeOutTimes();
    this.bridge = bridge;
  }

  //---------------------------------------------------------------
  public void run() {
    String line;
    boolean startedXML = false;
    int indexStart;
    int indexEnd;
    int currID = 0;
    StringBuffer sb = new StringBuffer();
    while (true) {
      try {
        line = bridge.getSmlReader().readLine();
        bridge.log(1, "[[from sml: " + line + "]]");
        if (startedXML) {
          indexEnd = line.indexOf(END_SEQ);
          if (indexEnd != -1) {
            sb.append(line.substring(0, indexEnd));
            timeOutTimes.removeElementAt(0);
            // remove first (oldest) element from timeOutTimes

            if (bridge.ignoreOutput == 0) {
              // send XML-string (response of sml-kernel) to client
              String s = new String(sb);
              //TODO: FIXXME: removes the id in response:
              s = s.substring(2); 
              PrintWriter pw = clientList.getPrintWriterOfClient(currID);
              if (pw != null) {
                pw.println(s);
              }
              bridge.responseSent();
            } else {
              bridge.ignoreOutput--;
              bridge.log(1, "ignored output");
            }
            startedXML = false;
          } else {
            sb.append(line);
          }
        } else {
          indexStart = line.indexOf(START_SEQ);
          if (indexStart != -1) {
            sb = new StringBuffer();            
            currID = 1;
            //TODO: retrieve clientID from XML-Output
            bridge.log(1, "found clientid: " + currID);
            startedXML = true;
          }
        }
      } catch (IOException e) {      	
      	//bridge.log(1, "Read from sml-kernel failed, waiting for kernel to restart");                
      } catch (NullPointerException e) {
        bridge.log(1, "Read from sml-kernel failed, waiting for kernel to restart"); 	
      } catch (IndexOutOfBoundsException e) {
        bridge.log(1, "KI2Clients: Index out of bound");
        e.printStackTrace();
      } catch (NumberFormatException e) {
        bridge.log(1, "Couldn't parse user ID");
      } 
    }
  }
}
