/*
 * Created on Aug 13, 2003
 */
package isac.bridge;

/**
 * @author rgradisc
 */
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

public class SMLThread implements Runnable {

  private Process process;
  public boolean is_exited;

  Vector inputBuffer;

  protected String execution_commandos[] = new String[2];

  private InputStream smlInput;
  private OutputStream smlOutput;
  private BridgeMain bridge;

  public SMLThread(BridgeMain bridge, String kernelExec, String kernelArgs) {
    /*execution_commandos[0] = "/bin/sh";
    execution_commandos[1] = "-c";
    execution_commandos[2] = "./start_kernel";
    */
    
    //execution_commandos[0] = "sml";
    //execution_commandos[1] = "@SMLload=/radish/isac/data/isac-WI";
    
    
    //changed 28.8.03:
    execution_commandos[0] = kernelExec;
    execution_commandos[1] = kernelArgs;
    bridge.log(1, kernelExec);
    bridge.log(1, kernelArgs);

    this.bridge = bridge;
    process = null;
    is_exited = false;
    inputBuffer = new Vector();
  }

  //---------------------------------------------------------------
  /**
  * returns the InputStream from the Kernel
  *
  **/
  public synchronized InputStream getInputStream() {
    try {
      smlInput = process.getInputStream();
    } catch (java.lang.NullPointerException null_pointer_exception) {
      //System.out.println("NullpointerException" + null_pointer_exception);
      try {
        wait(20);
      } catch (InterruptedException e) {
        System.out.println("getInputStream: " + e); // DEBUG
      }
      smlInput = getInputStream(); // recurse until stream ready
    }
    return smlInput;
  }

  //---------------------------------------------------------------
  /**
  * returns the OutputStream from the Kernel
  *
  **/
  public synchronized OutputStream getOutputStream() {
    try {
      smlOutput = process.getOutputStream();
    } catch (java.lang.NullPointerException null_pointer_exception) {
      //System.out.println("NullpointerException" + null_pointer_exception);
      try {
        wait(20);
      } catch (InterruptedException e) {
        System.out.println("getOutputStream: " + e); // DEBUG
      }
      smlOutput = getOutputStream(); // recurse until stream ready
    }
    return smlOutput;
  }

  //---------------------------------------------------------------
  /**
  * starts the ISAC - Kernel
  *
  **/
  public void run() {
    Runtime runtime = Runtime.getRuntime();
    // start sml
    try {
      process = runtime.exec(execution_commandos);
    } catch (IOException e) {
      e.printStackTrace();
      is_exited = true;
      return;
    }

    // wait until sml has terminated    
    while (!is_exited) {
      try {
        process.waitFor();
      } catch (InterruptedException e) {
        bridge.log(1, "SMLThread INTERRUPTED");
        break;
      }
      is_exited = true;
    }
    try {
      smlInput.close();      
      smlOutput.close();
    } catch (IOException e) {
      bridge.log(1, "Cannot close SML Streams");
      e.printStackTrace();
    }
    bridge.log(1, "SML Streams closed");
    process.destroy(); // Destroy process and I/O streams    
    bridge.log(1, "SML Process destroyed");
    bridge.log(1, getInputStream().toString());
  }
}
