/*
 * Created on Sep 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util;


/**
 * @author Alan Krempler
 *
 * Interface to be used to communicate in the direction towards the Math Engine.
 * 
 */

public interface IToCalc {
	
	/**
	 * Get a new iterator referencing the root element of the calculation tree. 
	 * <p> The functionality for navigating the calculation 
	 * is implemented in the CalcIterator object.
	 * @return new instance of CalcIterator
	 */
	public ICalcIterator iterator();
	  
	/**
	 * Register a new listener who wants to be notified of changes in the data.
	 * The listener has to implement the IToUser interface.
	 * 
	 * @param listener New listener to be registered.
	 * @return false on success, true otherwise.
	 * @see IToUser
	 */  
	public boolean addListener(IToUser listener);
	
	/**
	 * @return an iterator referencing the current
	 * "hot spot" in the calculation, i.e. the active formula.
	 *
	 */
	public ICalcIterator getActiveFormula();
	  
}
