/*
 * Created on Sep 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.util;


import java.io.Serializable;


/**
 * @author Alan Krempler
 *
 * Interface to be used to communicate in the direction towards the user..
 */
public interface IToUser extends Serializable {
	/**
	 * Notify a listener of changes in the data.
	 * 
	 * @param last_unchanged_formula Last unchanged formula. 
	 * All data up to this formula are not affected by the update.
	 * @param transaction_id Identifies the transaction which caused the change in the data.
	 * @param success true, if the transaction which triggered the change has completed successfully. 
	 * This implies that no further updates from this transaction are expected. 
	 * false otherwise.
	 */
	public void calcChanged(CalcChangedEvent event);
}
