(* interface to knowledge interpreter
   use"../FE-interface/interface.sml";
   use"FE-interface/interface.sml";
   use"interface.sml";
   *)


(***. CalcTree .***)

(** add and delete users -----------------------------------------------
 FIXXME.8.03 addUser: clear code, because only CalcTrees distinguished**)

(*7.10.03: addUser left for quick-and-dirty version for RG*)
fun addUser (cI:calcID) = adduserOK2xml (add_user ((*cI:calcID*)));
fun addUserTEST (cI:calcID) = add_user ((*cI:calcID*));
fun Iterator (cI:calcID) = adduserOK2xml (add_user ((*cI:calcID*)));
fun IteratorTEST (cI:calcID) = add_user (*cI:calcID*);
fun delUser (cI:calcID) (uI:userID) = deluserOK2xml (del_user (*cI*) uI);
(*---------------------------------------------------------------------*)

fun CalcTree
	[(fmz:fmz, sp:spec)] (*for several variants lateron*) =
    let val cs = nxt_specify_init_calc (fmz, sp)
	(*FIXME.WN.8.03: error-handling missing*)
	val cI = add_calc 1 (e_pos', cs)
    in calctreeOK2xml cI  end;

fun DEconstrCalcTree (cI:calcID) = 
    deconstructcalctreeOK2xml (del_calc 1 cI);

fun moveActiveFormula (cI:calcID) (uI:userID) (pos:pos') =
    let val (ip, ((pt,_),_)) = get_state 1 cI
    in if existpt' ip pt then (upd_ipos 1 cI ip; iteratorOK2xml cI)
       else sysERROR2xml cI (*worksheet sends a non-existing pos*) end;
 
fun setNextTactic (cI:calcID) (uI:userID) tac =
    case applytac tac (get_state 1 cI) of
	   ("ok", cs)  => 
	   (upd_calc 1 cI cs; setnexttactic2xml cI "ok")
	 | ("unsafe-ok", cs) => 
	    (upd_calc 1 cI cs; setnexttactic2xml cI "unsafe-ok")
	 | ("not-applicable",_) => setnexttactic2xml cI "not-applicable"   
	 | ("end-of-calculation",_) => 
	   setnexttactic2xml cI "end-of-calculation"   
	 | ("failure",_) => sysERROR2xml cI;

fun fetchProposedTactic (cI:calcID) (uI:userID) = 
    (case nexttac (get_state 1 cI) of
	   ("ok", ts as (tac,_,_)::_) => 
	   (upd_tacis 1 cI ts; fetchproposedtacticOK2xml cI tac)
	 | ("helpless",_) => fetchproposedtacticERROR2xml cI "helpless"
	 | ("no-fmz-spec",_) => fetchproposedtacticERROR2xml cI "no-fmz-spec"
	 | ("end-of-calculation",_) => 
	   fetchproposedtacticERROR2xml cI "end-of-calculation")
    handle _ => sysERROR2xml cI;

fun refFormula cI (uI:userID) =
    (let val (ip, ((pt,_),_)) = get_state 1 cI
	 val (form, tac, asms, safe) = pt_extract (pt, ip)
    in refformulaOK2xml cI form end)
    handle _ => sysERROR2xml cI; (*FIXME.WN.29.8.03 refformulaERROR2xml ? *)


(***. CalcIterator .***)

fun moveRoot cI (uI:userID) =
    (let val _ = upd_ipos 1 cI ([],Frm)
    in iteratorOK2xml cI end)
    handle e => sysERROR2xml cI;
fun moveRootTEST cI (uI:userID) =
    (let val _ = upd_ipos 1 cI ([],Frm)
    in (*iteratorOK2xml cI*)() end)
    handle e => sysERROR2xml cI;

fun moveDown cI (uI:userID) =
    ((let val (ip, ((pt,_),_)) = get_state 1 cI
	  val ip' = move_dn [] pt ip
	  val _ = upd_ipos 1 cI ip'
      in iteratorOK2xml cI end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI;
fun moveDownTEST cI (uI:userID) =
    let val (ip, ((pt,_),_)) = get_state 1 cI
	  val ip' = (move_dn [] pt ip)
	      handle _ => ip
	  val _ = upd_ipos 1 cI ip'
      in (*iteratorOK2xml cI*)() end;

fun moveLevelDown cI (uI:userID) =
    ((let val (ip, ((pt,_),_)) = get_state 1 cI
	  val ip' = movelevel_dn [] pt ip
	  val _ = upd_ipos 1 cI ip'
      in iteratorOK2xml cI end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI;

fun moveUp cI (uI:userID) =
    ((let val (ip, ((pt,_),_)) = get_state 1 cI
	  val ip' = move_up [] pt ip
	  val _ = upd_ipos 1 cI ip'
      in iteratorOK2xml cI end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI;

fun moveLevelUp cI (uI:userID) =
    ((let val (ip, ((pt,_),_)) = get_state 1 cI
	  val ip' = movelevel_up [] pt ip
	  val _ = upd_ipos 1 cI ip'
      in iteratorOK2xml cI end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI;
    

(***. for mathematics authoring on sml-toplevel; no XML .***)

type NEW = int list;
(* val sp = (dI',pI',mI');
   *)
fun CalcTreeTEST [(fmz:fmz, sp:spec)] = 
    let val _ = (states:= []; addUserTEST 1);
	val cs as ((pt,p), (tac,_,_)::_) = nxt_specify_init_calc (fmz, sp);
	val f = TESTg_form (pt,p);
	val _ = (add_calc 1 (e_pos', cs); moveRootTEST 1);
    in (p, []:NEW, f, (tac2IDstr tac, tac), Sundef, pt) end; 
       
(*for tests > 15.8.03 after separation setnexttactic / nextTac:
  external view: me should be used by math-authors as done so far
  internal view: loc_specify/solve, nxt_specify/solve used
                 i.e. same as in setnexttactic / nextTac*)
(*ENDE TESTPHASE 08/09.03:
  NEW loeschen, eigene Version von setnexttactic, nextTac
  meNEW, CalcTreeTEST: tac'_ -replace-> tac, remove [](cid) *)

(*functional except of ip, tacis*)
fun meNEW ((_,tac):tac'_) (p:pos') (_:NEW(*remove*)) (pt:ptree) =
(* val (_,tac) = nxt;
   *)
    let val (ip, (_,tacis)) = get_state 1 1;
(* val (_, cs as ((pt',_),_)) = applytac tac (ip, ((pt,p), tacis));
      val pt = pt';
   *)
	val (_, cs as ((pt,_),_)) = 
	    case applytac tac (ip, ((pt,p), tacis)) of
		("ok", cs)  => ("", cs)
	      | ("unsafe-ok", cs) => ("", cs)
	      | ("not-applicable",_) => ("not-applicable", ((pt,p),[]))
	      | ("end-of-calculation", cs) => ("", cs)
	      | ("failure",_) => raise error "sys-error"
	val ip = (move_dn [] pt ip) handle _ => ip; (*moveDown*)
(* val (_, ts) = nexttac (ip, cs);
   *)
	val (_, ts) = 
	    (case nexttac (ip, cs) of
		 ("ok", ts as (tac,_,_)::_) => ("",ts)
	       | ("helpless",_) => ("helpless: cannot propose tac", [])
	       | ("no-fmz-spec",_) => raise error "no-fmz-spec"
	       | ("end-of-calculation", ts) => ("",ts))
	    handle _ => raise error "sys-error"
	val _= upd_tacis 1 1 ts
	val _= upd_ipos 1 1 ip
	val tac = case ts of ((tac,_,_)::_) => tac | _ => End_Proof'
    in (ip:pos',[]:NEW, TESTg_form (pt,ip), 
	(tac2IDstr tac, tac):tac'_, Sundef, pt) end;


(*
 val ref [(1,[(1,(ip,((pt,p),(tac,_,_)::_),([],[])))])] = states;


*)
