(* use"ME/generate.sml";
   use"generate.sml";
*)



datatype pblmet =       (*%^%*)
    Upblmet             (*undefined*)
  | Problem of pblID    (*%^%*)
  | Method of metID;    (*%^%*)
fun pblmet2str (Problem pblID) = "Problem "^(strs2str pblID)(*%^%*)
  | pblmet2str (Method metID) = "Method "^(metID2str metID);(*%^%*)
      (*%^%*)   (*26.6. moved to sequent.sml: fun ~~~~~~~~~; was here below*)


(* copy from 03.60.usecases.sml 15.11.99 *)
datatype user_cmd = 
  Accept   | NotAccept | Example
| YourTurn | MyTurn (* internal use only 7.6.02 java-sml*)   
| Rules
| DontKnow  (*| HowComes | WhatFor       7.6.02 java-sml*)
| Undo      (*| Back          | Forward  7.6.02 java-sml*)
| EndProof | EndSession
| ActivePlus | ActiveMinus | SpeedPlus | SpeedMinus
                           (*Stepwidth...7.6.02 java-sml*)
| Auto | NotAuto | Details;
(* for test-print-outs *)
fun user_cmd2str Accept     ="Accept"
  | user_cmd2str NotAccept  ="NotAccept"
  | user_cmd2str Example    ="Example"
  | user_cmd2str MyTurn     ="MyTurn"
  | user_cmd2str YourTurn   ="YourTurn"
  | user_cmd2str Rules	    ="Rules"
(*| user_cmd2str HowComes   ="HowComes"*)
  | user_cmd2str DontKnow   ="DontKnow"
(*| user_cmd2str WhatFor    ="WhatFor"
  | user_cmd2str Back       ="Back"*)
  | user_cmd2str Undo       ="Undo"
(*| user_cmd2str Forward    ="Forward"*)
  | user_cmd2str EndProof   ="EndProof"
  | user_cmd2str EndSession ="EndSession"
  | user_cmd2str ActivePlus = "ActivePlus"
  | user_cmd2str ActiveMinus = "ActiveMinus"
  | user_cmd2str SpeedPlus = "SpeedPlus"
  | user_cmd2str SpeedMinus = "SpeedMinus"
  | user_cmd2str Auto = "Auto"
  | user_cmd2str NotAuto = "NotAuto"
  | user_cmd2str Details = "Details";



(*3.5.00: TODO: foppFK eliminated in interface FE-KE !!!*)
datatype foppFK =                  (* in DG cases div 2 *)
  EmptyFoppFK         (*DG internal*)
| FormFK of cterm'
| PpcFK of cterm' ppc;
fun foppFK2str (FormFK ct') ="FormFK "^ct'
  | foppFK2str (PpcFK  ppc) ="PpcFK "^(ppc2str ppc)
  | foppFK2str EmptyFoppFK  ="EmptyFoppFK";


datatype nest = Open | Closed | Nundef;
fun nest2str Open = "Open"
  | nest2str Closed = "Closed"
  | nest2str Nundef = "Nundef";

type indent = int;
datatype edit = EdUndef | Write | Protect;
                                   (* bridge --> kernel *)
                                   (* bridge <-> kernel *)
(* needed in dialog.sml *)         (* bridge <-- kernel *)
fun edit2str EdUndef = "EdUndef"
  | edit2str Write = "Write"
  | edit2str Protect = "Protect";


datatype inout =
  New_User | End_User                                          (*<->*)
| New_Proof | End_Proof                                        (*<->*)
| Command of user_cmd                                          (*-->*)
| Request of string | Message of string                        (*<--*) 
| Error_ of string  | System of string                         (*<--*)
| FoPpcFK of foppFK                                            (*-->*)
| FormKF of cellID * edit * indent * nest * cterm'             (*<--*)
| PpcKF of cellID * edit * indent * nest * (pblmet * item ppc) (*<--*)
| RuleFK of tac                                              (*-->*)
| RuleKF of edit * tac                                       (*<--*)
| RefinedKF of match list                                      (*<--*)
| Select of tac list                                         (*<--*)
| RefineKF of match list                                       (*<--*)
| Speed of int                                                 (*<--*)
| Active of int                                                (*<--*)
| Domain of domID;                                             (*<--*)

fun inout2str End_Proof = "End_Proof"
  | inout2str (Command user_cmd) = "Command "^(user_cmd2str user_cmd)
  | inout2str (Request s) = "Request "^s
  | inout2str (Message s) = "Message "^s
  | inout2str (Error_  s) = "Error_ "^s
  | inout2str (System  s) = "System "^s
  | inout2str (FoPpcFK foppFK) = "FoPpcFK "^(foppFK2str foppFK)
  | inout2str (FormKF (cellID, edit, indent, nest, ct')) =  
	       "FormKF ("^(string_of_int cellID)^","
	       ^(edit2str edit)^","^(string_of_int indent)^","
	       ^(nest2str nest)^",("
	       ^ct' ^")"
  | inout2str (PpcKF (cellID, edit, indent, nest, (pm,itemppc))) =
	       "PpcKF ("^(string_of_int cellID)^","
	       ^(edit2str edit)^","^(string_of_int indent)^","
	       ^(nest2str nest)^",("
	       ^(pblmet2str pm)^","^(itemppc2str itemppc)^"))"
  | inout2str (RuleKF (edit,tac)) = "RuleKF "^
	       pair2str(edit2str edit,tac2str tac)
  | inout2str (RuleFK tac) = "RuleFK "^(tac2str tac)  
  | inout2str (Select tacs)= 
	       "Select "^((strs2str' o (map tac2str)) tacs)
  | inout2str (RefineKF ms)  = "RefineKF "^(matchs2str ms)
  | inout2str (Speed i) = "Speed "^(string_of_int i)
  | inout2str (Active i) = "Active "^(string_of_int i)
  | inout2str (Domain dI) = "Domain "^dI;
fun inouts2str ios = (strs2str' o (map inout2str)) ios; 

datatype mout =
  Form' of inout         (* packing cterm' | cterm' ppc *)
| Problems of inout      (* passes specify (and solve)  *)
| Error' of inout
| EmptyMout;

fun mout2str (Form' inout) ="Form' "^(inout2str inout)
  | mout2str (Error'  inout) ="Error' "^(inout2str inout)
  | mout2str (EmptyMout    ) ="EmptyMout";



(*15.8.03 for me with loc_specify/solve, nxt_specify/solve
 delete as soon as TESTg_form -> _mout_ dropped*)
fun TESTg_form ptp =
(* val ptp = (pt,p);
   *) 
    let val (form,_,_,_) = pt_extract ptp
    in case form of
	   Form t => Form' (FormKF (~1,EdUndef,0,Nundef,term2str t))
	 | ModSpec (p_, gfr, pre, _) => 
	   Form' (PpcKF (0,EdUndef,0,Nundef,
			 (case p_ of Pbl => Problem[] | Met => Method[],
			  itms2itemppc (assoc_thy"Isac.thy") gfr pre)))
    end;



(* init pbl with ...,dsc,empty | [] *)
fun init_pbl pbt = 
  let 
    fun pbt2itm (f,(d,t)) = 
      ((0,[],false,f,Inc((d,[]),(e_term,[]))):itm);
  in map pbt2itm pbt end;


(*generate 1 ppobj in ptree*)
fun generate1 thy (Add_Given' (_, itmlist)) Uistate (pos as (p,p_)) pt = 
    (pos,[],Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
     case p_ of Pbl => update_pbl pt p itmlist
	      | Met => update_met pt p itmlist)
  | generate1 thy (Add_Find' (_, itmlist)) Uistate (pos as (p,p_)) pt = 
    (pos,[],Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
     case p_ of Pbl => update_pbl pt p itmlist
	      | Met => update_met pt p itmlist)
  | generate1 thy (Add_Relation' (_, itmlist)) Uistate (pos as (p,p_)) pt = 
    (pos,[],Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
     case p_ of Pbl => update_pbl pt p itmlist
	      | Met => update_met pt p itmlist)

  | generate1 thy (Specify_Theory' domID) Uistate (pos as (p,_)) pt = 
    (pos,[],Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
     update_domID pt p domID)

  | generate1 thy (Specify_Problem' (pI, (ok, (itms, pre)))) Uistate 
	      (pos as (p,_)) pt = 
    let val pt = update_pbl pt p itms
	val pt = update_pblID pt p pI
    in (pos,[],
	Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))), 
	pt) end

  | generate1 thy (Specify_Method' (mID, oris, itms)) Uistate 
	      (pos as (p,_)) pt = 
    let val pt = update_oris pt p oris
	val pt = update_met pt p itms
	val pt = update_metID pt p mID
    in ((p,Met),[],
	Form' (PpcKF (0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))), 
	pt) end

  | generate1 thy (Model_Problem' (_, itms)) Uistate (pos as (p,_)) pt =
(* val (itms,pos as (p,_)) = (pbl, pos);
   *)
    let val pt = update_pbl pt p itms
    in (pos,[],Form'(PpcKF(0,EdUndef,0,Nundef,
			   (Upblmet,itms2itemppc thy [][]))), pt) end

  | generate1 thy (Refine_Tacitly' (pI,pIre,domID,metID,pbl)) 
	      Uistate (pos as (p,_)) pt = 
    let val pt = update_pbl pt p pbl
	val pt = update_orispec pt p (domID,pIre,metID)
    in (pos,[],
	Form'(PpcKF(0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
	pt) end

  | generate1 thy (Refine_Problem' _) Uistate pos pt = (*only calls Spec_Pbl*)
    (pos,[],
     Form'(PpcKF(0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),pt)

  | generate1 thy (Apply_Method' (_,topt)) _ (pos as (p,p_)) pt = 
    (case topt of 
	 Some (t, is) => 
	 let val (pt,_) = cappend_form pt p is t
	 in (pos,[],
	     Form'(PpcKF(0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),
	     pt) end
       | None => 
	 (pos,[],
	  Form'(PpcKF(0,EdUndef,0,Nundef,(Upblmet,itms2itemppc thy [][]))),pt))

  | generate1 thy (Take' t) l (p,p_) pt = (* val (Take' t) = m; *)
  let val p = let val (ps,p') = split_last p(*no connex to prev.ppobj*)
	    in if p'=0 then ps@[1] else p end;
    val (pt,c) = cappend_form pt p l t;
  in ((p,Frm):pos', c, 
      Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str t)), pt) end

(* val (l, (p,p_)) = (RrlsState is, p);
   *)
  | generate1 thy (Begin_Trans' t) l (p,p_) pt =
  let val p = (lev_on o lev_dn) p; 
    val ct = Sign.string_of_term (sign_of thy) t;
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_form pt p l t;
  in ((p,Frm), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str t)), 
      pt) end

  | generate1 thy (End_Trans' t) l (p,p_) pt =
  let val (pt,c) = append_result pt p l (t,[]) Complete;
    val p' = lev_up p;
  in ((p',Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str t)),
      pt) end

  | generate1 thy (End_Detail' t) l (p,p_) pt = 
    generate1 thy (End_Trans' t) l (p,p_) pt

(*fun generate1 thy (Rewrite_Inst' (_,_,_,_,subs',thm',f,(f',asm))) l(p,p_)pt=
  let 
    val t2str = Sign.string_of_term (sign_of thy);
    val ff = t2str f;
    val ff' = t2str f';
    val subs = subst2subs subs';
    val asm' = map (Sign.string_of_term (sign_of thy)) asm;
    (*TODO: remove with rewrite term*)
    val (pt,c) = cappend_atomic pt p l ff
      (Rewrite_Inst (subs,thm')) (ff',asm') Complete;
    val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, ff')), pt) end
;*)
  | generate1 thy (Rewrite_Inst' (_,_,_,_,subs',thm',f,(f',asm))) l (p,p_) pt =
  let val (pt,c) = cappend_atomic pt p l f
      (Rewrite_Inst (subst2subs subs',thm')) (f',asm) Complete;
    (*val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm);9.6.03??*)
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt) end

  | generate1 thy (Rewrite' (thy',ord',rls',pa,thm',f,(f',asm))) l (p,p_) pt =
  let     val (pt,c) = cappend_atomic pt p l f 
      (Rewrite thm') (f',asm) Complete;
    (*val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm);9.6.03??*)
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt)end

  | generate1 thy (Rewrite_Asm' all) l p pt = generate1 thy (Rewrite' all) l p pt

  | generate1 thy (Rewrite_Set_Inst' (_,_,subs',rls',f,(f',asm))) l (p,p_) pt =
  let val (pt,c) = cappend_atomic pt p l f 
      (Rewrite_Set_Inst (subst2subs subs',id_rls rls')) (f',asm) Complete;
    (*val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');9.6.03??*)
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt) end

  | generate1 thy (Rewrite_Set' (_,_,rls',f,(f',asm))) l (p,p_) pt =
  let val (pt,c) = cappend_atomic pt p l f 
      (Rewrite_Set (id_rls rls')) (f',asm) Complete;
    (*val pt = union_asm pt (par_pblobj pt p) (map (rpair p) asm');9.6.03??*)
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt) end

  | generate1 thy (Check_Postcond' (pI,(scval,asm))) l (p,p_) pt =
    let (*val (l',_) = get_obj g_loc pt p..don't overwrite with l from subpbl*)
	val (pt,c) = 
	    append_result pt p l (scval,map str2term asm) 
			  Complete
    in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), 
				   Nundef, term2str scval)), 
	pt) end

  | generate1 thy (Calculate' (thy',op_,f,(f',thm'))) l (p,p_) pt =
  let val (pt,c) = cappend_atomic pt p l f 
      (Calculate op_) (f',[]) Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt)end

  | generate1 thy (Check_elementwise' (consts,pred,(f',asm))) l (p,p_) pt =
    let val (pt,c) = cappend_atomic pt p l consts 
	(Check_elementwise pred) (f',asm) Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, term2str f')),
      pt)end

  | generate1 thy (Or_to_List' (ors,list)) l (p,p_) pt =
    let val (pt,c) = cappend_atomic pt p l ors 
	Or_to_List (list,[]) Complete;
  in ((p,Res), c, Form' (FormKF(~1,EdUndef,(length p), Nundef, term2str list)),
      pt)end

  | generate1 thy (Tac_ (_,f,id,f')) l (p,p_) pt =
    let val (pt,c) = cappend_atomic pt p l (str2term f) 
				    (Tac id) (str2term f',[]) Complete;
  in ((p,Res), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, f')), pt)end

  | generate1 thy (Subproblem' ((domID, pblID, metID), oris, f)) l (p,p_) pt =
    let val (pt,c) = cappend_problem pt p l (oris, (domID, pblID, metID));
	(*val pbl = init_pbl ((#ppc o get_pbt) pblID);
	val pt = update_pblppc pt p pbl;--------4.9.03->Model_Problem*)
	(*val _= writeln("### generate1: is([3],Frm)= "^
		       (istate2str (get_istate pt ([3],Frm))));*)
	val f = Sign.string_of_term (sign_of thy) f;
    in ((p,Pbl), c, Form' (FormKF (~1,EdUndef,(length p), Nundef, f)), pt) end

  | generate1 thy m' _ _ _ = 
    raise error ("generate1: not impl.for "^(tac_2str m'))
;


fun generate_hard thy m' (p,p_) pt =
  let  
    val p = case p_ of Frm => p | Res => lev_on p
  | _ => raise error ("generate_hard: call by "^(pos'2str (p,p_)));
  in generate1 thy m' e_istate (p,p_) pt end;
